<div *ngIf="dataLoaded" class="container">
    <div class="row">
        <div class="col-lg-7">
            <div class="card card-bordered card-flush shadow-sm">
                <div class="card-header">
                    <div class="container p-0">
                        <div class="row mt-3">
                            <h3 class="card-title" i18n>Pending Tasks</h3>
                        </div>
                    </div>
                    
                </div>
                <div class="card-body top-card-label">
       
                    <div class="row pb-4" *ngFor="let row of pending_tasks">
                        <div class="col-lg-6" >
                            <div class="d-flex align-items-center me-15 mb-2">
                                <span class="bullet bullet-dot bg-primary h-15px w-15px me-5"></span> 
                                {{this.task_dictionary[row.id]}}
                            </div>
                        </div>

                        <div class="col-md-2 text-center" >
                            <strong>{{this.periodicity_dictionary[row.periodicity]}}</strong>
                        </div>
                        <div class="col-md-2" >
                           <strong>{{row.points}} {{this.points_trans}}</strong>
                        </div>
                        <div class="col-md-2"  >
                            <div [ngSwitch]="row.id">
                                <a *ngSwitchCase="'ad-seen'" (click)="openDisplayAdsModal(display_ads_modal)" class="task-btn btn btn-outline btn-outline-dashed btn-outline-primary btn-active-light-primary">Task link</a>
                                <a *ngSwitchCase="'upload-personal-details-data'" (click)="openPersonalDataModal(personal_data_modal)" class="task-btn btn btn-outline btn-outline-dashed btn-outline-primary btn-active-light-primary">Task link</a>
                                <a *ngSwitchCase="'set-consents'" (click)="openSetConsentsModal(set_consents_modal)" class="task-btn btn btn-outline btn-outline-dashed btn-outline-primary btn-active-light-primary">Task link</a>
                                <a *ngSwitchCase="'plugin-installation'" (click)="openDownloadPluginModal(download_plugin_modal)" class="task-btn btn btn-outline btn-outline-dashed btn-outline-primary btn-active-light-primary">Task link</a>
                                <a *ngSwitchCase="'upload-browsing-data'" (click)="openDownloadPluginModal(download_plugin_modal)" class="task-btn btn btn-outline btn-outline-dashed btn-outline-primary btn-active-light-primary">Task link</a>
                                <a *ngSwitchCase="'browse-web'" (click)="openBrowseWebModal(browse_web_modal)" class="task-btn btn btn-outline btn-outline-dashed btn-outline-primary btn-active-light-primary">Task link</a>
                                <a *ngSwitchCase="'invite-friends'" (click)="openInviteFriendsModal(invite_friends_modal)" class="task-btn btn btn-outline btn-outline-dashed btn-outline-primary btn-active-light-primary">Task link</a>
                                <a *ngSwitchCase="'upload-location-data'" (click)="openLocationHistoryModal(location_history_modal)" class="task-btn btn btn-outline btn-outline-dashed btn-outline-primary btn-active-light-primary">Task link</a>
                                <a *ngSwitchCase="'participating-marketplace'" (click)="openParticipateMarketplaceModal(participate_marketplace_modal)" class="task-btn btn btn-outline btn-outline-dashed btn-outline-primary btn-active-light-primary">Task link</a>
                            </div>
                        </div>

                    </div>
                </div>
                <div class="card-footer">
                    <div class="container p-0">
                        <div class="row">
                            <span class="mt-1 fw-bold fs-7" i18n>Remember to complete all tasks to participate in the sweepstakes.</span>  
                        </div>          
                        <div class="row justify-content-md-center mt-5">
                            <div class="col col-lg-5">
                                <a (click)="openViewCompletedTasksModal(view_completed_tasks_modal)" class="btn btn-sm btn-primary"><i
                                    class="las la-history fs-1 me-2"></i>{{view_task_history}}</a>
                              </div>
                        </div>                
                    </div>
                </div>
            </div>

        </div>
        <div class="col-md-auto">
            <div class="card card-flush card-bordered shadow-sm">
                <div class="card-header point-title">
                    <div class="d-flex justify-content-center">
                        <h3 class="card-title" i18n>Total points</h3>
                    </div>
                </div>
                <div class="card-body top-card-label">
                    <div class="d-flex justify-content-center">
                        <h1>{{points}}</h1>
                    </div>

                  
                </div>

                <div class="card-footer">
                    <div class="container p-0">
                        <div class="row">
                            <span class="mt-1 fw-bold fs-4" i18n>Points this month: <span class="points">{{this.points_month}}</span></span>  
                        </div>
                        <div class="row">
                            <span class="mt-1 fw-bold fs-4" i18n>Points this week: <span class="points">{{this.points_week}}</span></span>  
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<div class="container mt-5">
    <div class="row">
        <div class="col-lg-7">
            <div class="row">
                <div class="card card-bordered card-flush shadow-sm">
                    <div class="card-header">
                        <div class="container p-0">
                            <div class="row mt-3">
                                <h3 class="card-title" i18n>Extra points</h3>
                            </div>
                            <div class="row">
                                <span class="text-muted mt-1 fw-bold fs-7" i18n>
                                    Do you want to earn extra points? Complete these extra tasks to earn more points.
                                </span>    
                            </div>
                        </div>                </div>
                    <div class="card-body top-card-label">
           
                        <div class="row pb-4" *ngFor="let row of extra_tasks">
                            <div class="col-lg-6" >
                                <div class="d-flex align-items-center me-15 mb-2">
                                    <span class="bullet bullet-dot bg-primary h-15px w-15px me-5"></span> 
                                    {{this.task_dictionary[row.id]}}
                                </div>
                            </div>
    

                            <div class="col-md-2" >
                                <strong>{{this.periodicity_dictionary[row.periodicity]}}</strong>
                            </div>
                            <div class="col-md-2" >
                               <strong>{{row.points}} {{this.points_trans}}</strong>
                            </div>
                            <div class="col-md-2"  >
                                <div [ngSwitch]="row.id">
                                    <a *ngSwitchCase="'display-ads'" (click)="openDisplayAdsModal(display_ads_modal)" class="task-btn btn btn-outline btn-outline-dashed btn-outline-primary btn-active-light-primary">Task link</a>
                                    <a *ngSwitchCase="'ad-seen'" (click)="openDisplayAdsModal(display_ads_modal)" class="task-btn btn btn-outline btn-outline-dashed btn-outline-primary btn-active-light-primary">Task link</a>
                                    <a *ngSwitchCase="'upload-personal-details-data'" (click)="openPersonalDataModal(personal_data_modal)" class="task-btn btn btn-outline btn-outline-dashed btn-outline-primary btn-active-light-primary">Task link</a>
                                    <a *ngSwitchCase="'set-consents'" (click)="openSetConsentsModal(set_consents_modal)" class="task-btn btn btn-outline btn-outline-dashed btn-outline-primary btn-active-light-primary">Task link</a>
                                    <a *ngSwitchCase="'plugin-installation'" (click)="openDownloadPluginModal(download_plugin_modal)" class="task-btn btn btn-outline btn-outline-dashed btn-outline-primary btn-active-light-primary">Task link</a>
                                    <a *ngSwitchCase="'upload-browsing-data'" (click)="openDownloadPluginModal(download_plugin_modal)" class="task-btn btn btn-outline btn-outline-dashed btn-outline-primary btn-active-light-primary">Task link</a>
                                    <a *ngSwitchCase="'browse-web'" (click)="openBrowseWebModal(browse_web_modal)" class="task-btn btn btn-outline btn-outline-dashed btn-outline-primary btn-active-light-primary">Task link</a>
                                    <a *ngSwitchCase="'invite-friends'" (click)="openInviteFriendsModal(invite_friends_modal)" class="task-btn btn btn-outline btn-outline-dashed btn-outline-primary btn-active-light-primary">Task link</a>
                                    <a *ngSwitchCase="'upload-location-data'" (click)="openLocationHistoryModal(location_history_modal)" class="task-btn btn btn-outline btn-outline-dashed btn-outline-primary btn-active-light-primary">Task link</a>
                                    <a *ngSwitchCase="'participating-marketplace'" (click)="openParticipateMarketplaceModal(participate_marketplace_modal)" class="task-btn btn btn-outline btn-outline-dashed btn-outline-primary btn-active-light-primary">Task link</a>
                                </div>
                            </div>
    
                        </div>
    
                    </div>
                    
                </div>
            </div>
            <div class="row">
                <div class="card card-bordered card-flush shadow-sm mt-3">
                    <div class="card-header">
                        <h3 class="card-title" i18n>Prizes</h3>
                    </div>
                        
                    <div class="card-body">
                        <ngx-slick-carousel class="carousel" 
                          #slickModal="slick-carousel" 
                          [config]="slideConfig" >
                            <div ngxSlickItem *ngFor="let sweepstake of next_sweepstakes" class="slide">
                                <div class="card" style="width: 18rem;">
                                    <img class="card-img-top modal-image mx-auto d-block" *ngIf="sweepstake.prize == '200€ Gift card'" src="./assets/media/images/amazon-card-200.png">
                                    <img class="card-img-top modal-image mx-auto d-block" *ngIf="sweepstake.prize == '2000€ Amazon Gift Card'" src="./assets/media/images/amazon-card-2500.png">
                                    <img class="card-img-top modal-image mx-auto d-block" *ngIf="sweepstake.prize == 'iPhone 13'" src="./assets/media/images/iphone.png">
    
                                    <div class="card-body text-center">
                                      <h2 class="card-title mb-5">{{sweepstake.prize}}</h2>

                                      <p class="card-text mb-2">{{sweepstake_description_dictionary[sweepstake.description]}}</p>
                                      <p *ngIf="sweepstake.pointsNeeded > 0" class="card-text mb-2" i18n>(Getting {{sweepstake.pointsNeeded}} points)</p>

                                      <span *ngIf="sweepstake.pointsNeeded == 0" class="green-sweepstake mt-1 fw-bold fs-2" i18n>
                                        Goal reached!
                                    </span>  
                                      <p class="card-text">x{{sweepstake.amount}}</p>
                                    </div>
                                  </div>
                            </div>
                        </ngx-slick-carousel>
                    </div>
                </div>
            </div>

        </div>
        <div class="col-md-auto">
            <div class="card card-bordered card-flush shadow-sm">
                <div class="card-header">
                    <h3 class="card-title" i18n>Next Sweepstakes</h3>
                </div>
                <div class="card-body">
                    <div class="sweepstake card mb-2 card-bordered card-flush" *ngFor="let sweepstake of next_sweepstakes">
                        <div class="card-header">
                            <div class="container p-0 ">
                                <div class="row mt-3">
                                    <div class="d-flex justify-content-center">
                                        <h5 class="card-title">{{sweepstake.date}}</h5>
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="d-flex justify-content-center">
                                        <span class="text-muted mt-1 fw-bold fs-7">{{sweepstake_description_dictionary[sweepstake.description]}}&nbsp;</span>    
                                    </div>
                                </div>
                            </div>
                        </div>
                    <div class="no-margin-padding card-body">
                        <div class="d-flex justify-content-center">

                            <span class="green-sweepstake mt-1 fw-bold fs-5" *ngIf="sweepstake.pointsNeeded === 0" i18n>
                                Goal reached!
                            </span>  
                            <span class="red-sweepstake mt-1 fw-bold fs-5" *ngIf="sweepstake.pointsNeeded > 0" i18n>
                                Get {{sweepstake.pointsNeeded}} more points.
                            </span> 
                        </div>
                    </div>
                    <div class="no-margin-padding card-footer">
                        <div class="d-flex justify-content-center">
                            <span class="mt-1 fw-bold fs-5" i18n>Prize:&nbsp;</span>  
                            <span class="mt-1 fw-bold fs-5"><strong>{{sweepstake.prize}}</strong></span>  
                        </div>
                    </div>
                </div>

                </div>
                <div class="card-footer">
                    <div class="d-flex justify-content-center">
                        <span class="mt-1 fw-bold fs-7 " *ngIf="next_sweepstakes.length > 4">
                            <a href="#" class="btn btn-bg-light btn-color-primary"><u i18n>View all sweepstakes</u></a>
                        </span>  
                    </div>

                </div>
            </div>        
        </div>
    </div>
</div>


<!-- BROWSE THE WEB MODAL START -->
<ng-template #browse_web_modal let-modal>
    <div class="modal-header">
        <h4 class="modal-title" id="modal-title" i18n>Browse the web</h4>
        <button type="button" class="close" aria-describedby="modal-title" (click)="modal.dismiss('Cross click')">
        <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div class="modal-body d-flex justify-content-center">
        <div class="container">
            <div class="row">
                <p i18n>
                    Browsing with Google Chrome
                </p>
                <p i18n>
                    This task only requires using your browser once you have installed and
                    activated the plugin. Through the navigation we will be able to know and
                    generate a profile with your interests and share it with those companies that
                    request it.
                </p>
                <p i18n>
                    This is a daily task and every day you browse adds 10 points to your account.
                </p>
            </div>
        </div>
    </div>
    <div class="modal-footer">
        <a class="btn btn-sm btn-secondary" (click)="modal.dismiss('Cross click')" i18n>Close</a>
    </div>
</ng-template>
<!-- BROWSE THE WEB MODAL END -->


<!-- PERSONAL DATA MODAL START -->
<ng-template #personal_data_modal let-modal>
    <div class="modal-header">
        <h4 class="modal-title" id="modal-title" i18n>Personal data</h4>
        <button type="button" class="close" aria-describedby="modal-title" (click)="modal.dismiss('Cross click')">
        <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div class="modal-body d-flex justify-content-center">
        <div class="container">
            <div class="row">

                <p i18n>
                    Enter personal data to share with third parties.
                </p>
                <p i18n>
                    To complete this task you have to enter in the MyData section at least the data
                    marked mandatory (*). This data can be updated at any time from the
                    &quot;MyData&quot; menu option.
                </p>
                <p i18n>
                    This data is shared with third parties, data buyers who request it through
                    EasyPIMS. The more data you share, the more likely it is that your profile will be
                    attractive to these companies.
                </p>
                <p i18n>
                    Completing this task accumulates 50 points.
                </p>

            </div>
        </div>
    </div>
    <div class="modal-footer">
        <a class="btn btn-sm btn-secondary" (click)="modal.dismiss('Cross click')" i18n>Close</a>
        <a (click)="modal.close('Go')" class="btn btn-sm btn-primary" i18n>Fill the data</a>
    </div> 
</ng-template>
<!-- PERSONAL DATA MODAL END -->

<!-- SET CONSENTS MODAL START -->
<ng-template #set_consents_modal let-modal>
    <div class="modal-header">
        <h4 class="modal-title" id="modal-title" i18n>Set consents</h4>
        <button type="button" class="close" aria-describedby="modal-title" (click)="modal.dismiss('Cross click')">
        <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div class="modal-body d-flex justify-content-center">
        <div class="container">
            <div class="row">
                <p i18n>
                    Configure &quot;My consents&quot;
                </p>
                <p i18n>
                    Private companies, public agencies and educational institutions may request
                    your data for specific purposes. When you check a box, you give permission to
                    share your data for the purpose you select to all those who want to acquire
                    your data for that purpose.For each organization that requests data that you
                    have shared, you will receive 50 points that accumulate in your private account.
                </p>
                <p i18n>
                    Those offers for which you have not uploaded your data either because you
                    have not uploaded them or because you have not given permission to share
                    them will be lost.
                </p>
                <p i18n>
                    Completing this task accumulates 50 points.
                </p>
            </div>
        </div>
    </div>
    <div class="modal-footer">
        <a class="btn btn-sm btn-secondary" (click)="modal.dismiss('Cross click')" i18n>Close</a>
        <a (click)="modal.close('Go')" class="btn btn-sm btn-primary" i18n>Set consents</a>
    </div> 
</ng-template>
<!-- SET CONSENTS MODAL END -->

<!-- DOWNLOAD PLUGIN MODAL START -->
<ng-template #download_plugin_modal let-modal>
    <div class="modal-header">
        <h4 class="modal-title" id="modal-title" i18n>Download Plugin</h4>
        <button type="button" class="close" aria-describedby="modal-title" (click)="modal.dismiss('Cross click')">
        <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div class="modal-body d-flex justify-content-center">
        <div class="container">
            <div class="row">
                <p i18n>
                    Install the plugin for Chrome
                </p>
                <p i18n>
                    A plugin is an extension that is installed on your web browser to extend and
                    increase its functionality.
                </p>
                <p i18n>
                    The functionality of the EasyPIMS plugin, for Google Chrome, is to collect your
                    browsing data to know your interests and do it automatically without you
                    having to do anything more than navigate. This way we can generate a
                    profile of interests that you can consult and make available to those companies
                    that request it.
                </p>
                <p i18n>
                    This Plugin is only available for Google Chrome, to download it click on the
                    button &quot;DOWNLOAD PLUGIN&quot; and then click on &quot;Add to Chrome&quot;.
                </p>
                <p i18n>
                    Completing this task adds 250 points to your account.
                </p>
            </div>
        </div>
    </div>
    <div class="modal-footer">
        <a class="btn btn-sm btn-secondary" (click)="modal.dismiss('Cross click')" i18n>Close</a>
        <a (click)="modal.close('Go')" class="btn btn-sm btn-primary" i18n>Download plugin</a>
    </div> 
</ng-template>
<!-- DOWNLOAD PLUGIN MODAL END -->

<!-- DISPLAY ADS MODAL START -->
<ng-template #display_ads_modal let-modal>
    <div class="modal-header">
        <h4 class="modal-title" id="modal-title" i18n>Display Ads</h4>
        <button type="button" class="close" aria-describedby="modal-title" (click)="modal.dismiss('Cross click')">
        <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div class="modal-body d-flex justify-content-center">
        <div class="container">
            <div class="row">
                <p i18n>
                    View 3 or more ads
                </p>
                <p i18n>
                    This is a daily task in which we show you three different ads and ask you to rate
                    your interest in each ad shown.
                </p>
                <p i18n>
                    Completing this task adds 10 points to your accumulated points.                </p>
            </div>
        </div>
    </div>
    <div class="modal-footer">
        <a class="btn btn-sm btn-secondary" (click)="modal.dismiss('Cross click')" i18n>Close</a>
        <a (click)="modal.close('Go')" class="btn btn-sm btn-primary" i18n>View Ads</a>

    </div>
</ng-template>
<!-- DISPLAY ADS MODAL END -->

<!-- INVITE FRIENDS MODAL START -->
<ng-template #invite_friends_modal let-modal>
    <div class="modal-header">
        <h4 class="modal-title" id="modal-title" i18n>Invite friends</h4>
        <button type="button" class="close" aria-describedby="modal-title" (click)="modal.dismiss('Cross click')">
        <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div class="modal-body d-flex justify-content-center">
        <div class="container">
            <div class="row">
                <p i18n>Invite your friends</p>

                <p i18n>This task consists of sending the personalized link we show you to your friends
                    inviting them to join EasyPIMS as betatesters.</p>

                <p i18n>For each person who registers through your personalized link and completes all of
                    the tasks you will receive a total of 350 points.</p>

            </div>
        </div>
    </div>
    <div class="modal-footer">
        <a class="btn btn-sm btn-secondary" (click)="modal.dismiss('Cross click')" i18n>Close</a>
        <a (click)="modal.close('Go')" class="btn btn-sm btn-primary" i18n>Invite friends</a>

    </div>
</ng-template>
<!-- INVITE FRIENDS MODAL END -->

<!-- LOCATION HISTORY MODAL START -->
<ng-template #location_history_modal let-modal>
    <div class="modal-header">
        <h4 class="modal-title" id="modal-title" i18n>Upload location history</h4>
        <button type="button" class="close" aria-describedby="modal-title" (click)="modal.dismiss('Cross click')">
        <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div class="modal-body d-flex justify-content-center">
        <div class="container">
            <div class="row">
                <p i18n>Upload geolocation history</p>

                <p i18n>
                    This extra task allows you to share the geolocation data generated when using
                    Google Maps. To upload this data to EasyPIMS you must first download it
                    from Google Maps and then upload it to our platform.
                </p>

                <p i18n>In this video we show you the complete process of how to do it.</p>
                
                <p i18n>Completing this task adds 250 extra points to your account.</p>
             </div>
        </div>
    </div>
    <div class="modal-footer">
        <a class="btn btn-sm btn-secondary" (click)="modal.dismiss('Cross click')" i18n>Close</a>
        <a (click)="modal.close('Go')" class="btn btn-sm btn-primary" i18n>Upload location history</a>

    </div>
</ng-template>
<!-- LOCATION HISTORY MODAL END -->

<!-- PARTICIPATE MARKETPLACE MODAL START -->
<ng-template #participate_marketplace_modal let-modal>
    <div class="modal-header">
        <h4 class="modal-title" id="modal-title" i18n>Participate in the marketplace</h4>
        <button type="button" class="close" aria-describedby="modal-title" (click)="modal.dismiss('Cross click')">
        <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div class="modal-body d-flex justify-content-center">
        <div class="container">
            <div class="row">
                <p i18n>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent vel pretium orci, id pharetra lorem. Aenean vitae ullamcorper nisi, sed mattis mi. Nunc non eros vehicula, tincidunt neque non, dictum mi. Nulla id nisi nec mauris facilisis vestibulum non eu ex. Donec et urna ac est finibus accumsan. Ut ultrices sit amet mauris eu tristique. Pellentesque tincidunt ultrices nisl in sollicitudin. Nulla auctor facilisis orci, at pulvinar nisi ultricies vel. Nulla mollis felis sit amet ipsum placerat semper. Nullam gravida euismod neque, vel suscipit orci porta vel. Duis ac metus massa. Duis ultrices lacus nec urna bibendum, in rhoncus nisl condimentum. In id tortor id nisi vehicula tristique. Praesent augue velit, dictum quis imperdiet nec, ullamcorper condimentum est. Nam nisi ipsum, rutrum vel sollicitudin ut, finibus ut diam. Praesent efficitur arcu sollicitudin ex auctor varius.</p>
            </div>
        </div>
    </div>
    <div class="modal-footer">
        <a class="btn btn-sm btn-secondary" (click)="modal.dismiss('Cross click')" i18n>Close</a>
    </div>
</ng-template>
<!-- PARTICIPATE MARKETPLACE MODAL END -->

<!-- VIEW COMPLETED TASKS MODAL START -->
<ng-template #view_completed_tasks_modal let-modal>
    <div class="modal-header">
        <h4 class="modal-title" id="modal-title" i18n>Completed tasks</h4>
        <button type="button" class="close" aria-describedby="modal-title" (click)="modal.dismiss('Cross click')">
        <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div class="modal-body d-flex justify-content-center">
        <div class="container">
            <div *ngIf="this.completed_tasks.length === 0" class="row text-center">
                <h2 i18n>You have not completed any task yet!</h2>
            </div>


            <table *ngIf="completed_tasks.length > 0 " class="table table-rounded table-striped border gy-7 gs-7">
                <thead>
                    <tr class="fw-bold fs-6 text-gray-800 border-bottom border-gray-200">
                        <th i18n>Name</th>
                        <th i18n>Type</th>
                        <th i18n>Date</th>
                        <th i18n>Points</th>
                    </tr>
                </thead>
                <tbody>
                    <tr *ngFor="let row of this.transaction_history" >
                        <td *ngIf="row.type == 'dataOffer'" i18n>Shared {{this.data_offers_dictionary[row.metadata.dataTypes[0]]}} data: <strong>Commercial purpose</strong></td>
                        <td *ngIf="row.type == 'task'"><strong>{{this.task_dictionary[row.metadata.taskId]}}</strong></td>
                        <td>{{this.task_type_dictionary[row.type]}}</td>
                        <td>{{row.date |titlecase}}</td>
                        <td class="text-primary"><strong>+ {{row.points}}</strong></td>
                    </tr>
                </tbody>
            </table>

        </div>
    </div>
    <div class="modal-footer">
        <a class="btn btn-sm btn-secondary" (click)="modal.dismiss('Cross click')" i18n>Close</a>
    </div>
</ng-template>
<!-- VIEW COMPLETED TASKS MODAL END -->

<ngx-spinner></ngx-spinner>
